SystemOrganization addCategory: #'JQWidgetBox-JQTools-Tabs-Core'!

!JQueryInstance methodsFor: '*jqwidgetbox-jqtools-tabs-core' stamp: 'NickAger 2/9/2010 13:36'!
jqToolsTabs
	^ self create: JQToolsTabs! !

JQWidget subclass: #JQToolsTabs
	instanceVariableNames: 'panesSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-JQTools-Tabs-Core'!

!JQToolsTabs commentStamp: 'NickAger 2/8/2010 15:02' prior: 0!
I am the Seaside binding for the JQuery Tools tabs control
See: http://flowplayer.org/tools/tabs.html
!

!JQToolsTabs methodsFor: 'options' stamp: 'NickAger 2/12/2010 23:34'!
api: aBoolean
	"default: false
	When this tool is initialized (constructed), the return value is a jQuery object associated with the selector. By setting this property to true, the return value is this tool's JavaScript API instead. If the selector returns multiple elements, the API of the last element will be returned. Read more about accessing the tool API (http://flowplayer.org/tools/using.html#api)"
	self optionAt: 'api' put: aBoolean! !

!JQToolsTabs methodsFor: 'accessing' stamp: 'NickAger 2/9/2010 11:02'!
arguments
	(panesSelector isNil) ifTrue: [self error: 'you must define a selector the the content, see panesSelector: and samples'].
	
	^ (Array with: panesSelector), super arguments! !

!JQToolsTabs methodsFor: 'options' stamp: 'NickAger 2/12/2010 23:34'!
current: aString
	"default: 'current'
	the CSS class name for the currently active tab"
	self optionAt: 'current' put: aString! !

!JQToolsTabs methodsFor: 'options' stamp: 'NickAger 2/12/2010 23:34'!
effect: aString
	"default: 'default'
	The effect to be used when a tab is clicked. This can dramatically change the behaviour of the tabs. Here are available built-in effects:
	* default': a simple show / hide effect. The default behaviour for tabs.
	* 'fade': the tab contents are gradually shown from zero to full opacity.
	* 'ajax': loads tab contents from the server using AJAX. 
	* 'slide': a vertical sliding effect, suitable for accordions
	* 'horizontal' a horizontal sliding effect, suitable for horizontal accordions"
	self optionAt: 'effect' put: aString! !

!JQToolsTabs methodsFor: 'options' stamp: 'NickAger 2/12/2010 23:34'!
event: aString
	"default: 'click'
	Specifies the event when a tab is opened. By default, this happens when the user clicks on the tab. Other valid values are 'mouseover' and 'dblclick'."
	self optionAt: 'event' put: aString! !

!JQToolsTabs methodsFor: 'options' stamp: 'NickAger 2/12/2010 23:34'!
fadeInSpeed: aNumber
	"default: 200
	Only available when used together with the fade effect. This property defines how fast (in milliseconds) the opened pane reveals its content."
	self optionAt: 'fadeInSpeed' put: aNumber! !

!JQToolsTabs methodsFor: 'options' stamp: 'NickAger 2/12/2010 23:34'!
fadeOutSpeed: aNumber
	"default: 0
	Only available when used together with the fade effect. This property defines how fast (in milliseconds) the opened pane hides its content. A positive value here will result in a cool crossfade effect which is demonstrated in this slideshow demo: - http://flowplayer.org/tools/tabs.html#slideshow"
	self optionAt: 'fadeOutSpeed' put: aNumber! !

!JQToolsTabs methodsFor: 'options' stamp: 'NickAger 2/12/2010 23:34'!
initialIndex: aNumber
	"default: 0
	Specifies the tab that is initially opened when the page loads. This automatically triggers a click event for the tab specified in this property. Specifying null or a negative number here will not trigger the click event upon page load causing all tabs to be initially closed"
	self optionAt: 'initialIndex' put: aNumber! !

!JQToolsTabs methodsFor: 'accessing' stamp: 'NickAger 2/9/2010 10:53'!
method
	^'tabs'! !

!JQToolsTabs methodsFor: 'options' stamp: 'NickAger 2/12/2010 23:33'!
onBeforeCallback: aCallback
	"default: null
	This callback function is triggered before a tab is clicked and returning false in the callback prevents the tab from opening
		function(event, tabIndex)"
	self optionAt: 'onBeforeCallback' put: (aCallback asFunction: #('event' 'tabIndex'))	! !

!JQToolsTabs methodsFor: 'options' stamp: 'NickAger 2/12/2010 23:33'!
onClick: aCallback
	"default: null
	This callback function is triggered after a tab is clicked
		function(event, tabIndex)"
	self optionAt: 'onClick' put: (aCallback asFunction: #('event' 'tabIndex'))! !

!JQToolsTabs methodsFor: 'options' stamp: 'NickAger 2/12/2010 23:33'!
panesSelector: aJQuery
	"the jQuery expression to select the elements containing the tab content"
	panesSelector := aJQuery! !

!JQToolsTabs methodsFor: 'options' stamp: 'NickAger 2/12/2010 23:33'!
rotate: aBoolean
	"default: false
	When the last tab is open and the next() API call is invoked, then the tabs will start from the beginning and when the first tab is open and the prev() call is invoked the tabs will advance to the last tab. This is demonstrated in the slideshow demo - http://flowplayer.org/tools/tabs.html#slideshow"
	self optionAt: 'rotate' put: aBoolean! !

!JQToolsTabs methodsFor: 'options' stamp: 'NickAger 2/12/2010 23:33'!
tabs: aString
	"default: 'a'
	A selector for elements that are used as tabs inside the root element. If none are found then the direct children of the root element are used as tabs."
	self optionAt: 'tabs' put: aString	! !

!JQWidgetBoxDeploymentLibrary methodsFor: '*jqwidgetbox-jqtools-tabs-core' stamp: 'NickAger 2/9/2010 16:26'!
toolstabs104Js
	^ '/*
 * tools.tabs 1.0.4 - Tabs done right.
 * 
 * Copyright (c) 2009 Tero Piirainen
 * http://flowplayer.org/tools/tabs.html
 *
 * Dual licensed under MIT and GPL 2+ licenses
 * http://www.opensource.org/licenses
 *
 * Launch  : November 2008
 * Date: ${date}
 * Revision: ${revision} 
 */
(function(d){d.tools=d.tools||{};d.tools.tabs={version:"1.0.4",conf:{tabs:"a",current:"current",onBeforeClick:null,onClick:null,effect:"default",initialIndex:0,event:"click",api:false,rotate:false},addEffect:function(e,f){c[e]=f}};var c={"default":function(f,e){this.getPanes().hide().eq(f).show();e.call()},fade:function(g,e){var f=this.getConf(),j=f.fadeOutSpeed,h=this.getPanes();if(j){h.fadeOut(j)}else{h.hide()}h.eq(g).fadeIn(f.fadeInSpeed,e)},slide:function(f,e){this.getPanes().slideUp(200);this.getPanes().eq(f).slideDown(400,e)},ajax:function(f,e){this.getPanes().eq(0).load(this.getTabs().eq(f).attr("href"),e)}};var b;d.tools.tabs.addEffect("horizontal",function(f,e){if(!!b){b=this.getPanes().eq(0).width()}this.getCurrentPane().animate({width:0},function(){d(this).hide()});this.getPanes().eq(f).animate({width:b},function(){d(this).show();e.call()})});function a(g,h,f){var e=this,j=d(this),i;d.each(f,function(k,l){if(d.isFunction(l)){j.bind(k,l)}});d.extend(this,{click:function(k,n){var o=e.getCurrentPane();var l=g.eq(k);if(typeof k=="string"&&k.replace("#","")){l=g.filter("[href*="+k.replace("#","")+"]");k=Math.max(g.index(l),0)}if(f.rotate){var m=g.length-1;if(k<0){return e.click(m,n)}if(k>m){return e.click(0,n)}}if(!!l.length){if(i>=0){return e}k=f.initialIndex;l=g.eq(k)}if(k===i){return e}n=n||d.Event();n.type="onBeforeClick";j.trigger(n,[k]);if(n.isDefaultPrevented()){return}c[f.effect].call(e,k,function(){n.type="onClick";j.trigger(n,[k])});n.type="onStart";j.trigger(n,[k]);if(n.isDefaultPrevented()){return}i=k;g.removeClass(f.current);l.addClass(f.current);return e},getConf:function(){return f},getTabs:function(){return g},getPanes:function(){return h},getCurrentPane:function(){return h.eq(i)},getCurrentTab:function(){return g.eq(i)},getIndex:function(){return i},next:function(){return e.click(i+1)},prev:function(){return e.click(i-1)},bind:function(k,l){j.bind(k,l);return e},onBeforeClick:function(k){return this.bind("onBeforeClick",k)},onClick:function(k){return this.bind("onClick",k)},unbind:function(k){j.unbind(k);return e}});g.each(function(k){d(this).bind(f.event,function(l){e.click(k,l);return false})});if(location.hash){e.click(location.hash)}else{if(f.initialIndex===0||f.initialIndex>0){e.click(f.initialIndex)}}h.find("a[href^=#]").click(function(k){e.click(d(this).attr("href"),k)})}d.fn.tabs=function(i,f){var g=this.eq(typeof f=="number"?f:0).data("tabs");if(g){return g}if(d.isFunction(f)){f={onBeforeClick:f}}var h=d.extend({},d.tools.tabs.conf),e=this.length;f=d.extend(h,f);this.each(function(l){var j=d(this);var k=j.find(f.tabs);if(!!k.length){k=j.children()}var m=i.jquery?i:j.children(i);if(!!m.length){m=e==1?d(i):j.parent().find(i)}g=new a(k,m,f);j.data("tabs",g)});return f.api?g:this}})(jQuery);'! !
